from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.ATAudio.config import PROJECTNAME, GLOBALS
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.CMFCorePermissions import ManagePortal
from StringIO import StringIO

# Configlets to be added to control panels or removed from them
configlets = (
{     'id'         : 'ATAudioSetup'
    , 'name'       : 'ATAudio Setup'
    , 'action'     : 'string:${portal_url}/prefs_ataudio_form'
    , 'condition'  : ''
    , 'category'   : 'Products'    # section to which the configlet should be added:
                                  # (Plone,Products,Members)
    , 'visible'    : 1
    , 'appId'      : PROJECTNAME
    , 'permission' : ManagePortal
    , 'imageUrl'   : 'audio_icon.gif'
},
            )

def install(self):

    out = StringIO()


    ctr = getToolByName(self, 'content_type_registry')

    if 'macosx_regex' not in ctr.predicate_ids:
        ctr.addPredicate('macosx_regex', 'name_regex' )
        ctr.getPredicate('macosx_regex').edit('._+')
        ctr.assignTypeName('macosx_regex', 'File')
        ctr.reorderPredicate('macosx_regex', 0)
        out.write('Installed CTR Predicate for ignoring MacOS X resource forks.\n')
    else:
        out.write('Predicate for ignoring MacOS X resource forks.\n')

    if 'mp3_ext' not in ctr.predicate_ids:
        ctr.addPredicate('mp3_ext', 'extension' )
        ctr.getPredicate('mp3_ext').edit('mp3')
        ctr.assignTypeName('mp3_ext', 'ATAudio')
        ctr.reorderPredicate('mp3_ext', 1)
        out.write('Installed CTR Predicate for .mp3 -> ATAudio.\n')
    else:
        out.write('Predicate for .mp3 -> ATAudio was already installed.\n')

    # Install properties
#    self.portal_properties = getToolByName(self.root, 'portal_properties')

    if not hasattr(self.portal_properties, 'ataudio_properties'):
        self.portal_properties.addPropertySheet('ataudio_properties', 'ATAudio properties')
    
    props = self.portal_properties.ataudio_properties

    if not hasattr(props, 'media_server'):
        props._setProperty('media_server', "", 'string')
        
    if not hasattr(props, 'max_file_size'):
        props._setProperty('max_file_size', "", 'float')

    print >> out, "Successfully installed global ATAudio properties."

    ##
    ## Register ATAudioFolder as folderish content in plone, so it will
    ## get the appropriate folder_contents tabs
    props = self.portal_properties.site_properties
    tabs = getattr(props, 'use_folder_tabs')
    contents = getattr(props, 'use_folder_contents')

    if 'ATAudioFolder' not in tabs:
        newtabs = list(tabs)
        newtabs.append('ATAudioFolder')
        props._updateProperty('use_folder_tabs', newtabs)

    if 'ATAudioFolder' not in contents:
        newcontents = list(contents)
        newcontents.append('ATAudioFolder')
        props._updateProperty('use_folder_contents', newcontents)

    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)

    install_subskin(self, out, GLOBALS)

    # add the configlets to the portal control panel
#    configTool = getToolByName(self, 'portal_controlpanel', None)
#    if configTool:
#        for conf in configlets:
#            configTool.registerConfiglet(**conf)
#            out.write('Added configlet %s\n' % conf['id'])
    
    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()

def uninstall(self):
    out = StringIO()
    
    # remove the configlets from the portal control panel
#    configTool = getToolByName(self, 'portal_controlpanel', None)
#    if configTool:
#      for conf in configlets:
#          configTool.unregisterConfiglet(conf['id'])
#          out.write('Removed configlet %s\n' % conf['id'])
    
    print >> out, "Successfully uninstalled %s." % PROJECTNAME
    return out.getvalue()
